/*
 * Copyright (C) Huawei Technologies Co., Ltd. 2023-2025. All rights reserved.
 * SPDX-License-Identifier: MIT
 */

/**
 * This C file call all available atomic APIs
 * It is not meant for running. It is to be used with `vsyncer info` in
 * different Configs to ensure the used barriers match the config.
 */
#include <vsync/atomic.h>

/* !!!Warning: File generated by tmplr; DO NOT EDIT.!!! */

vatomic8_t g_u8_a;
vuint8_t g_u8_v;
vatomic16_t g_u16_a;
vuint16_t g_u16_v;
vatomic32_t g_u32_a;
vuint32_t g_u32_v;
vatomic64_t g_u64_a;
vuint64_t g_u64_v;
vatomicptr_t g_ptr_a;
void *g_ptr_v;
vatomicsz_t g_sz_a;
vsize_t g_sz_v;

int
main(void)
{
    vatomic8_read(&g_u8_a);
    vatomic8_read_acq(&g_u8_a);
    vatomic8_read_rlx(&g_u8_a);
    vatomic16_read(&g_u16_a);
    vatomic16_read_acq(&g_u16_a);
    vatomic16_read_rlx(&g_u16_a);
    vatomic32_read(&g_u32_a);
    vatomic32_read_acq(&g_u32_a);
    vatomic32_read_rlx(&g_u32_a);
    vatomic64_read(&g_u64_a);
    vatomic64_read_acq(&g_u64_a);
    vatomic64_read_rlx(&g_u64_a);
    vatomicsz_read(&g_sz_a);
    vatomicsz_read_acq(&g_sz_a);
    vatomicsz_read_rlx(&g_sz_a);
    vatomicptr_read(&g_ptr_a);
    vatomicptr_read_acq(&g_ptr_a);
    vatomicptr_read_rlx(&g_ptr_a);
}
