/*
 * Copyright (C) Huawei Technologies Co., Ltd. 2023-2025. All rights reserved.
 * SPDX-License-Identifier: MIT
 */

/* !!!Warning: File generated by tmplr; DO NOT EDIT.!!! */
#include <pthread.h>
#include <assert.h>
#include <vsync/atomic.h>
#define N  5
#define IT 10
vatomicsz_t g_shared;
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_inc
 *****************************************************************************/
static inline void *
mt_atomic_inc_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_inc(&g_shared);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_inc(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_inc_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_dec
 *****************************************************************************/
static inline void *
mt_atomic_dec_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_dec(&g_shared);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_dec(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_dec_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init - (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_inc_rel
 *****************************************************************************/
static inline void *
mt_atomic_inc_rel_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_inc_rel(&g_shared);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_inc_rel(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_inc_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_dec_rel
 *****************************************************************************/
static inline void *
mt_atomic_dec_rel_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_dec_rel(&g_shared);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_dec_rel(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_dec_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init - (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_inc_rlx
 *****************************************************************************/
static inline void *
mt_atomic_inc_rlx_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_inc_rlx(&g_shared);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_inc_rlx(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_inc_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_dec_rlx
 *****************************************************************************/
static inline void *
mt_atomic_dec_rlx_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_dec_rlx(&g_shared);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_dec_rlx(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_dec_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init - (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_sub
 *****************************************************************************/
static inline void *
mt_atomic_sub_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_sub(&g_shared, 0xFFU);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_sub(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_sub_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init - (N * IT * 0xFFU);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_add
 *****************************************************************************/
static inline void *
mt_atomic_add_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_add(&g_shared, 0xFFU);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_add(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_add_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT * 0xFFU);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_sub_rel
 *****************************************************************************/
static inline void *
mt_atomic_sub_rel_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_sub_rel(&g_shared, 0xFFU);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_sub_rel(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_sub_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init - (N * IT * 0xFFU);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_add_rel
 *****************************************************************************/
static inline void *
mt_atomic_add_rel_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_add_rel(&g_shared, 0xFFU);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_add_rel(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_add_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT * 0xFFU);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_sub_rlx
 *****************************************************************************/
static inline void *
mt_atomic_sub_rlx_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_sub_rlx(&g_shared, 0xFFU);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_sub_rlx(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_sub_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init - (N * IT * 0xFFU);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_add_rlx
 *****************************************************************************/
static inline void *
mt_atomic_add_rlx_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_add_rlx(&g_shared, 0xFFU);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_add_rlx(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_add_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT * 0xFFU);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_cmpxchg
 *****************************************************************************/
static inline void *
mt_atomic_cmpxchg_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    vsize_t cur = 0;
    vsize_t old = 0;
    for (vsize_t i = 0; i < IT; i++) {
        do {
            cur = vatomicsz_read(&g_shared);
            old = vatomicsz_cmpxchg(&g_shared, cur, cur + 1);
        } while (cur != old);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_cmpxchg(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_cmpxchg_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_cmpxchg_rel
 *****************************************************************************/
static inline void *
mt_atomic_cmpxchg_rel_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    vsize_t cur = 0;
    vsize_t old = 0;
    for (vsize_t i = 0; i < IT; i++) {
        do {
            cur = vatomicsz_read(&g_shared);
            old = vatomicsz_cmpxchg_rel(&g_shared, cur, cur + 1);
        } while (cur != old);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_cmpxchg_rel(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_cmpxchg_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_cmpxchg_acq
 *****************************************************************************/
static inline void *
mt_atomic_cmpxchg_acq_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    vsize_t cur = 0;
    vsize_t old = 0;
    for (vsize_t i = 0; i < IT; i++) {
        do {
            cur = vatomicsz_read(&g_shared);
            old = vatomicsz_cmpxchg_acq(&g_shared, cur, cur + 1);
        } while (cur != old);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_cmpxchg_acq(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_cmpxchg_acq_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_cmpxchg_rlx
 *****************************************************************************/
static inline void *
mt_atomic_cmpxchg_rlx_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    vsize_t cur = 0;
    vsize_t old = 0;
    for (vsize_t i = 0; i < IT; i++) {
        do {
            cur = vatomicsz_read(&g_shared);
            old = vatomicsz_cmpxchg_rlx(&g_shared, cur, cur + 1);
        } while (cur != old);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_cmpxchg_rlx(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_cmpxchg_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    /* calculate the expected value */
    vsize_t expected = init + (N * IT);
    vsize_t val      = vatomicsz_read(&g_shared);
    assert(expected == val);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_xchg
 *****************************************************************************/
static inline void *
mt_atomic_xchg_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        (void)vatomicsz_xchg(&g_shared, (vsize_t)tid);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_xchg(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_xchg_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    vsize_t val = vatomicsz_read(&g_shared);
    for (vsize_t i = 0; i < N; i++) {
        if (val == (vsize_t)i) {
            return;
        }
    }
    assert(0 && "value is none of the expected");
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_xchg_acq
 *****************************************************************************/
static inline void *
mt_atomic_xchg_acq_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        (void)vatomicsz_xchg_acq(&g_shared, (vsize_t)tid);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_xchg_acq(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_xchg_acq_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    vsize_t val = vatomicsz_read(&g_shared);
    for (vsize_t i = 0; i < N; i++) {
        if (val == (vsize_t)i) {
            return;
        }
    }
    assert(0 && "value is none of the expected");
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_xchg_rel
 *****************************************************************************/
static inline void *
mt_atomic_xchg_rel_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        (void)vatomicsz_xchg_rel(&g_shared, (vsize_t)tid);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_xchg_rel(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_xchg_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    vsize_t val = vatomicsz_read(&g_shared);
    for (vsize_t i = 0; i < N; i++) {
        if (val == (vsize_t)i) {
            return;
        }
    }
    assert(0 && "value is none of the expected");
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_xchg_rlx
 *****************************************************************************/
static inline void *
mt_atomic_xchg_rlx_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        (void)vatomicsz_xchg_rlx(&g_shared, (vsize_t)tid);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_xchg_rlx(void)
{
    vsize_t init = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_xchg_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    vsize_t val = vatomicsz_read(&g_shared);
    for (vsize_t i = 0; i < N; i++) {
        if (val == (vsize_t)i) {
            return;
        }
    }
    assert(0 && "value is none of the expected");
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_max
 *****************************************************************************/
static inline void *
mt_atomic_max_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_max(&g_shared, (vsize_t)tid);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_max(void)
{
    vsize_t init = 0;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_max_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == (N - 1));
    V_UNUSED(val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_max_rel
 *****************************************************************************/
static inline void *
mt_atomic_max_rel_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_max_rel(&g_shared, (vsize_t)tid);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_max_rel(void)
{
    vsize_t init = 0;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_max_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == (N - 1));
    V_UNUSED(val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_max_rlx
 *****************************************************************************/
static inline void *
mt_atomic_max_rlx_run(void *args)
{
    vsize_t tid = (vsize_t)(vuintptr_t)args;
    for (vsize_t i = 0; i < IT; i++) {
        vatomicsz_max_rlx(&g_shared, (vsize_t)tid);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_max_rlx(void)
{
    vsize_t init = 0;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_max_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == (N - 1));
    V_UNUSED(val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_and
 *****************************************************************************/
static inline void *
mt_atomic_and_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_and(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_and(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_and_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected & mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_or
 *****************************************************************************/
static inline void *
mt_atomic_or_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_or(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_or(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_or_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected | mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_xor
 *****************************************************************************/
static inline void *
mt_atomic_xor_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_xor(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_xor(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_xor_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected ^ mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_and_rel
 *****************************************************************************/
static inline void *
mt_atomic_and_rel_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_and_rel(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_and_rel(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_and_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected & mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_or_rel
 *****************************************************************************/
static inline void *
mt_atomic_or_rel_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_or_rel(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_or_rel(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_or_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected | mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_xor_rel
 *****************************************************************************/
static inline void *
mt_atomic_xor_rel_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_xor_rel(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_xor_rel(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_xor_rel_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected ^ mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_and_rlx
 *****************************************************************************/
static inline void *
mt_atomic_and_rlx_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_and_rlx(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_and_rlx(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_and_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected & mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_or_rlx
 *****************************************************************************/
static inline void *
mt_atomic_or_rlx_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_or_rlx(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_or_rlx(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_or_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected | mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * MultiThreadedTest: vatomicsz_xor_rlx
 *****************************************************************************/
static inline void *
mt_atomic_xor_rlx_run(void *args)
{
    vsize_t tid  = (vsize_t)(vuintptr_t)args;
    vsize_t mask = 0xF0F0F0F0U;

    for (vsize_t i = 0; i < IT; i++) {
        mask = mask << (i * tid);
        vatomicsz_xor_rlx(&g_shared, mask);
    }
    V_UNUSED(tid);
    return NULL;
}
static inline void
mt_atomic_xor_rlx(void)
{
    vsize_t init     = SIZE_MAX;
    vsize_t mask     = 0xF0F0F0F0U;
    vsize_t expected = SIZE_MAX;
    vatomicsz_init(&g_shared, init);
    pthread_t t[N];
    for (vsize_t i = 0; i < N; i++)
        pthread_create(&t[i], 0, mt_atomic_xor_rlx_run, (void *)i);
    for (vsize_t i = 0; i < N; i++)
        pthread_join(t[i], 0);
    for (vsize_t t = 0; t < N; t++) {
        mask = 0xF0F0F0F0U;
        for (vsize_t i = 0; i < IT; i++) {
            mask     = mask << (i * t);
            expected = expected ^ mask;
        }
    }
    vsize_t val = vatomicsz_read(&g_shared);
    assert(val == expected);
    V_UNUSED(expected, val);
}
/*****************************************************************************
 * Entry point
 *****************************************************************************/
int
main(void)
{
    mt_atomic_inc();
    mt_atomic_dec();
    mt_atomic_sub();
    mt_atomic_add();
    mt_atomic_max();
    mt_atomic_and();
    mt_atomic_or();
    mt_atomic_xor();
    mt_atomic_inc_rel();
    mt_atomic_dec_rel();
    mt_atomic_sub_rel();
    mt_atomic_add_rel();
    mt_atomic_max_rel();
    mt_atomic_and_rel();
    mt_atomic_or_rel();
    mt_atomic_xor_rel();
    mt_atomic_inc_rlx();
    mt_atomic_dec_rlx();
    mt_atomic_sub_rlx();
    mt_atomic_add_rlx();
    mt_atomic_max_rlx();
    mt_atomic_and_rlx();
    mt_atomic_or_rlx();
    mt_atomic_xor_rlx();
    mt_atomic_cmpxchg();
    mt_atomic_xchg();
    mt_atomic_cmpxchg_rel();
    mt_atomic_xchg_rel();
    mt_atomic_cmpxchg_acq();
    mt_atomic_xchg_acq();
    mt_atomic_cmpxchg_rlx();
    mt_atomic_xchg_rlx();
    return 0;
}
